#!/usr/bin/env python3

#This python code is from: http://numbergazing.org/
#by Gregory Bryant

from sys import argv
from sympy import integrate, symbols
from sympy.functions import Abs
x,y,n=symbols('x,y,n')



def get_p_formula(pwr):
	if(pwr==0):
		return n
	if(pwr==1):
		return n**2/2+n/2
	targetLevel = 3 #looking to get to the cubes
	temp = (n**3/3)+(n**2/2)+(n/6) #summation of squares
	for i in range(2,pwr):
		if(targetLevel%2):	#target level is odd, current formula is even
			temp = integrate(temp,n)*targetLevel
			targetLevel+=1
		else:	#target level is even, current formula is odd
			almostTemp = integrate(temp,n)*targetLevel
			almostOne=almostTemp.subs(n,1)
			errorVal=1-almostOne
			temp = almostTemp + errorVal*n
			targetLevel+=1
	return temp
	
def get_z_constant(num):
	if num == 1 or num == 2:
		return 1
	formula=1
	numTerms = ((num-3)*2)+1
	for i in range(0,numTerms):
		term = (n-(num-3)*2)+i
		formula *= term
	formula=formula.expand()
	targetLevel=2*num-4
	almostValue = formula.subs(n,targetLevel)
	powerFormula = get_p_formula(targetLevel)
	powerFormula = powerFormula.expand()
	targetCo = powerFormula.as_ordered_terms()[num-1]
	targetCo = targetCo.subs(n,1)
	targetCo = Abs(targetCo)
	theConstant = targetCo/almostValue
	return theConstant
	
	
	
	
	
	
	
	
	
	
	